
public class GaltonBrett {	
	private double p;
	private long[] baelle;
	
	public GaltonBrett(double p, int faecher) {
		if(p > 0 && p < 1 && faecher >= 2) {
			this.p = p;
			this.baelle = new long[faecher];
		} else {
			throw new IllegalArgumentException();
		}
	}
	
	private int linksOderRechts() {
		return (Math.random() < p) ? 1 : -1;
	}
	
	private int simLinRek(int ebenen) {
		if(ebenen < 1) {
			return 0;
		}
		
		return simLinRek(ebenen - 1) + linksOderRechts();
	}
	
	private int berechneFach(int diff) {
		int mid = baelle.length / 2;
		
		if(baelle.length % 2 == 0 && diff < 0)
			diff--;
		
		int fach = mid + (diff / 2);
		return fach;
	}
	
	public void simuliere(long n) {
		for(int i = 0; i < baelle.length; i++) {
			baelle[i] = 0;
		}
		
		int ebenen = baelle.length - 1;
		
		for(int i = 0; i < n; i++) {
			int fach = berechneFach(simLinRek(ebenen));
			baelle[fach]++;
		}
	}
	
	public void simuliereIter(long n) {
		for(int i = 0; i < baelle.length; i++) {
			baelle[i] = 0;
		}
		
		int ebenen = baelle.length - 1;
		
		for(int i = 0; i < n; i++) {
			int fach = berechneFach(simIter(ebenen));
			baelle[fach]++;
		}
	}
	
	private int simIter(int ebenen) {
		int diff = 0;
		
		while(ebenen > 0) {
			diff += linksOderRechts();
			ebenen--;
		}
		
		return diff;
	}
	
	public static void main(String[] args) {
		GaltonBrett gb = new GaltonBrett(0.5, 5);
		gb.simuliere(100);
		
		for(long l : gb.baelle)
			System.out.print(l + "   ");
		System.out.println();
		
		gb.simuliereIter(100);
		
		for(long l : gb.baelle)
			System.out.print(l + "   ");
		System.out.println();
		
		System.out.println();
		
		GaltonBrett gb2 = new GaltonBrett(0.5, 6);
		gb2.simuliere(100);
		
		for(long l : gb2.baelle)
			System.out.print(l + "   ");
		System.out.println();
		
		gb2.simuliereIter(100);
		
		for(long l : gb2.baelle)
			System.out.print(l + "   ");
		System.out.println();
	}
}
